

local sampev      = require("lib.samp.events")
local imgui       = require('imgui')
local main_window = imgui.ImBool(false)
local lovla       = imgui.ImBool(false)
local autoLovlya  = imgui.ImBool(false)
local autoPay     = imgui.ImBool(false)
local autoExit    = imgui.ImBool(false)
local flad        = imgui.ImBool(false)
local sportP      = {2, 5, 10, 11, 14, 17, 20, 23, 26, 29}; local lsp = imgui.ImBool(false)
local sport       = {1, 4, 8, 9, 13, 16, 19, 22, 25, 28}  ; local ls  = imgui.ImBool(false)
local impov       = {0, 3, 6, 7, 12, 15, 18, 21, 24, 27}  ; local li  = imgui.ImBool(false)
local delaybuy    = imgui.ImFloat(50)
local typeOut     = imgui.ImInt(1)
local typeLovla   = imgui.ImInt(1)
local typeLeave   = imgui.ImInt(1) 
local curretExit  = false
local encoding    = require 'encoding'
encoding.default = 'CP1251'
u8 = encoding.UTF8
function main()
    while not isSampAvailable() do wait(100) end
    sampAddChatMessage('[LovlaDetalek]: {FFFFFF} ,  - /ld',-300303)
    imgui.Process = main_window.v
    sampRegisterChatCommand('ldet',function()
        main_window.v = not main_window.v
    end)
	sampRegisterChatCommand("debugCMD", function()
		deleteChar(1)
		callFunction(0x823BDB, 3, 3, 0, 0, 0)
	end)
    while true do
        wait(0)
        
		if flad.v then
			local posX, posY, posZ = getCharCoordinates(playerPed)
			local ress, texts, colors, xs, ys, zs, distances, ignoreWallss, players, vehicles = Search3Dtext(posX, posY, posZ, 4.0, "   ")
			if ress then
				setGameKeyState(18, 255)
				wait(0)
				setGameKeyState(18, 0)
			end
		end
		if lovla.v then
			local posX, posY, posZ = getCharCoordinates(playerPed)
			local res, text, color, x, y, z, distance, ignoreWalls, player, vehicle = Search3Dtext(posX, posY, posZ, 4.0, "  ")
			if res then
				flad.v = true
				lovla.v = false
			end
		end
		
        imgui.Process = main_window.v
    end
end

function Search3Dtext(x, y, z, radius, patern)
    local text = ""
    local color = 0
    local posX = 0.0
    local posY = 0.0
    local posZ = 0.0
    local distance = 0.0
    local ignoreWalls = false
    local player = -1
    local vehicle = -1
    local result = false

    for id = 0, 2048 do
        if sampIs3dTextDefined(id) then
            local text2, color2, posX2, posY2, posZ2, distance2, ignoreWalls2, player2, vehicle2 = sampGet3dTextInfoById(id)
            if getDistanceBetweenCoords3d(x, y, z, posX2, posY2, posZ2) < radius then
                if string.len(patern) ~= 0 then
                    if string.match(text2, patern, 0) ~= nil then result = true end
                else
                    result = true
                end
                if result then
                    text = text2
                    color = color2
                    posX = posX2
                    posY = posY2
                    posZ = posZ2
                    distance = distance2
                    ignoreWalls = ignoreWalls2
                    player = player2
                    vehicle = vehicle2
                    radius = getDistanceBetweenCoords3d(x, y, z, posX, posY, posZ)
                end
            end
        end
    end

    return result, text, color, posX, posY, posZ, distance, ignoreWalls, player, vehicle
end

function imgui.OnDrawFrame()
    if main_window.v then
        local xw, yw = getScreenResolution()
        imgui.SetNextWindowPos(imgui.ImVec2(xw / 2 - 200, yw / 2), imgui.Cond.FirstUseEver)
        imgui.SetNextWindowSize(imgui.ImVec2(420, 300), imgui.Cond.FirstUseEver)
        imgui.Begin(u8' Impoved/Sport/Sport+ (v.2.0)||By VanoKLR',main_window)
        imgui.BeginChild('1',imgui.ImVec2(400,150),false)
        
        imgui.Checkbox(u8'',autoLovlya)
        imgui.Hint(u8"      ",0.3)
        imgui.SameLine()
        imgui.Checkbox(u8'',flad)
        imgui.Hint(u8"  (H)   ",0.3)
        imgui.SameLine()
        imgui.Checkbox(u8'',lovla)
        imgui.Hint(u8"          ( )",0.3)
        imgui.Checkbox(u8" ", autoPay)
        if autoPay.v then 
			imgui.SameLine() imgui.Checkbox(u8 "  ", autoExit) 
			if autoExit.v then
				imgui.RadioButton(u8"",typeOut,1)  imgui.SameLine() imgui.RadioButton(u8"",typeOut,2) 
			end 
		end
        imgui.Text(u8'') 
        imgui.SameLine()
        imgui.SliderFloat(u8"Delay", delaybuy, 1.0, 500) imgui.Hint(u8'   ',0.3) 
        imgui.EndChild()
        imgui.BeginChild('##2',imgui.ImVec2(150,90),false)
        imgui.Checkbox(u8 ' ', li)
        imgui.Checkbox(u8 ' ', ls)
        imgui.Checkbox(u8 '  ', lsp) imgui.SameLine()
        imgui.EndChild()imgui.SameLine()
		if typeOut.v == 1 then
			imgui.BeginChild('##3',imgui.ImVec2(75,90),false)
			imgui.RadioButton("Rage",typeLovla,1)imgui.RadioButton("Legit",typeLovla,2)
			imgui.EndChild() 
		elseif typeOut.v == 2 then
			imgui.SameLine()
			imgui.BeginChild('##5',imgui.ImVec2(75,90),false)
			imgui.RadioButton("/q", typeLeave,1)imgui.RadioButton("crash",typeLeave,2)
			imgui.EndChild()
		end
        imgui.End()
    end
end

function imgui.Hint(text, delay, action)
    if imgui.IsItemHovered() then
        if go_hint == nil then go_hint = os.clock() + (delay and delay or 0.0) end
        local alpha = (os.clock() - go_hint) * 5
        if os.clock() >= go_hint then
            imgui.PushStyleVar(imgui.StyleVar.WindowPadding, imgui.ImVec2(10, 10))
            imgui.PushStyleVar(imgui.StyleVar.Alpha, (alpha <= 1.0 and alpha or 1.0))
                imgui.PushStyleColor(imgui.Col.PopupBg, imgui.ImVec4(0.11, 0.11, 0.11, 1.00))
                    imgui.BeginTooltip()
                    imgui.PushTextWrapPos(450)
                    imgui.TextColored(imgui.GetStyle().Colors[imgui.Col.ButtonHovered], u8' :')
                    imgui.TextUnformatted(text)
                    if action ~= nil then
                        imgui.TextColored(imgui.GetStyle().Colors[imgui.Col.TextDisabled], '\n '..action)
                    end
                    if not imgui.IsItemVisible() and imgui.GetStyle().Alpha == 1.0 then go_hint = nil end
                    imgui.PopTextWrapPos()
                    imgui.EndTooltip()
                imgui.PopStyleColor()
            imgui.PopStyleVar(2)
        end
    end
end

function sampev.onShowDialog(dialogId,style,title,button1,button2,text)
    if text:find("       ") then
        sampSendDialogResponse(dialogId,1,nil,nil)
        sampCloseCurrentDialogWithButton(0)
        curretExit = true
        print("Pursed")
        return false
    end
end

addEventHandler('onSendPacket', function (id, bs, priority, reliability, orderingChannel) 
    if id == 220 then
        local id = raknetBitStreamReadInt8(bs)
        local packeautoLovlyaype = raknetBitStreamReadInt8(bs)
        local strlen = raknetBitStreamReadInt8(bs)
        raknetBitStreamIgnoreBits(bs, 24)
        local str = raknetBitStreamReadString(bs, strlen)
        if packeautoLovlyaype ~= 0 and packeautoLovlyaype ~= 1 and #str > 2 then
            if autoLovlya.v then
                if str == 'onActiveViewChanged|TuningStation' then
                    lua_thread.create(function()
                        wait(250)
                        if ls.v then
                            for i, v in ipairs(sport) do
                                emulationCEF('cartAdd|{"component": '..v..'}')
                                wait(delaybuy.v)
                            end
                        end
                        if li.v then
                            for i, v in ipairs(impov) do
                                emulationCEF('cartAdd|{"component": '..v..'}')
                                wait(delaybuy.v)
                            end
                        end
                        if lsp.v then
                            for i, v in ipairs(sportP) do
                                emulationCEF('cartAdd|{"component": '..v..'}')
                                wait(delaybuy.v)
                            end
                        end
                        if autoPay.v then
                            emulationCEF("purchase")
                        end
                        wait(1200)
                        if autoExit.v and autoPay.v then
                            if typeOut.v == 1 then
                                if typeLovla.v == 1 then
                                    emulationCEF("exit")
                                elseif typeLovla.v == 2 then
                                    wait(5000)
                                    emulationCEF("exit")
                                end
                            elseif typeOut.v == 2 then
                                if typeLeave.v == 1 then
                                    sampProcessChatInput("/q")
                                elseif typeLeave.v == 2 then
                                    deleteChar(1)
                                    callFunction(0x823BDB, 3, 3, 0, 0, 0)
                                end
                            end
                        end
                    end)
                end
            end
        end
    end
end)

emulationCEF = function(str)
    local bs = raknetNewBitStream()
    raknetBitStreamWriteInt8(bs, 220)
    raknetBitStreamWriteInt8(bs, 18)
    raknetBitStreamWriteInt32(bs, #str)
    raknetBitStreamWriteString(bs, str)
    raknetBitStreamWriteInt32(bs, 0)
    raknetSendBitStream(bs)
    raknetDeleteBitStream(bs)
end

function apply_custom_style()
    imgui.SwitchContext()
    local style = imgui.GetStyle()
    local colors = style.Colors
    local clr = imgui.Col
    local ImVec4 = imgui.ImVec4
    local ImVec2 = imgui.ImVec2

     style.WindowPadding = ImVec2(15, 15)
     style.WindowRounding = 15.0
     style.FramePadding = ImVec2(5, 5)
     style.ItemSpacing = ImVec2(12, 8)
     style.ItemInnerSpacing = ImVec2(8, 6)
     style.IndentSpacing = 25.0
     style.ScrollbarSize = 15.0
     style.ScrollbarRounding = 15.0
     style.GrabMinSize = 15.0
     style.GrabRounding = 7.0
     style.ChildWindowRounding = 8.0
     style.FrameRounding = 6.0

   colors[clr.Text] = ImVec4(0.95, 0.96, 0.98, 1.00)
   colors[clr.TextDisabled] = ImVec4(0.36, 0.42, 0.47, 1.00)
   colors[clr.WindowBg] = ImVec4(0.11, 0.15, 0.17, 1.00)
   colors[clr.ChildWindowBg] = ImVec4(0.15, 0.18, 0.22, 1.00)
   colors[clr.PopupBg] = ImVec4(0.08, 0.08, 0.08, 0.94)
   colors[clr.Border] = ImVec4(0.43, 0.43, 0.50, 0.50)
   colors[clr.BorderShadow] = ImVec4(0.00, 0.00, 0.00, 0.00)
   colors[clr.FrameBg] = ImVec4(0.20, 0.25, 0.29, 1.00)
   colors[clr.FrameBgHovered] = ImVec4(0.12, 0.20, 0.28, 1.00)
   colors[clr.FrameBgActive] = ImVec4(0.09, 0.12, 0.14, 1.00)
   colors[clr.TitleBg] = ImVec4(0.09, 0.12, 0.14, 0.65)
   colors[clr.TitleBgCollapsed] = ImVec4(0.00, 0.00, 0.00, 0.51)
   colors[clr.TitleBgActive] = ImVec4(0.08, 0.10, 0.12, 1.00)
   colors[clr.MenuBarBg] = ImVec4(0.15, 0.18, 0.22, 1.00)
   colors[clr.ScrollbarBg] = ImVec4(0.02, 0.02, 0.02, 0.39)
   colors[clr.ScrollbarGrab] = ImVec4(0.20, 0.25, 0.29, 1.00)
   colors[clr.ScrollbarGrabHovered] = ImVec4(0.18, 0.22, 0.25, 1.00)
   colors[clr.ScrollbarGrabActive] = ImVec4(0.09, 0.21, 0.31, 1.00)
   colors[clr.ComboBg] = ImVec4(0.20, 0.25, 0.29, 1.00)
   colors[clr.CheckMark] = ImVec4(0.28, 0.56, 1.00, 1.00)
   colors[clr.SliderGrab] = ImVec4(0.28, 0.56, 1.00, 1.00)
   colors[clr.SliderGrabActive] = ImVec4(0.37, 0.61, 1.00, 1.00)
   colors[clr.Button] = ImVec4(0.20, 0.25, 0.29, 1.00)
   colors[clr.ButtonHovered] = ImVec4(0.28, 0.56, 1.00, 1.00)
   colors[clr.ButtonActive] = ImVec4(0.06, 0.53, 0.98, 1.00)
   colors[clr.Header] = ImVec4(0.20, 0.25, 0.29, 0.55)
   colors[clr.HeaderHovered] = ImVec4(0.26, 0.59, 0.98, 0.80)
   colors[clr.HeaderActive] = ImVec4(0.26, 0.59, 0.98, 1.00)
   colors[clr.ResizeGrip] = ImVec4(0.26, 0.59, 0.98, 0.25)
   colors[clr.ResizeGripHovered] = ImVec4(0.26, 0.59, 0.98, 0.67)
   colors[clr.ResizeGripActive] = ImVec4(0.06, 0.05, 0.07, 1.00)
   colors[clr.CloseButton] = ImVec4(0.40, 0.39, 0.38, 0.16)
   colors[clr.CloseButtonHovered] = ImVec4(0.40, 0.39, 0.38, 0.39)
   colors[clr.CloseButtonActive] = ImVec4(0.40, 0.39, 0.38, 1.00)
   colors[clr.PlotLines] = ImVec4(0.61, 0.61, 0.61, 1.00)
   colors[clr.PlotLinesHovered] = ImVec4(1.00, 0.43, 0.35, 1.00)
   colors[clr.PlotHistogram] = ImVec4(0.90, 0.70, 0.00, 1.00)
   colors[clr.PlotHistogramHovered] = ImVec4(1.00, 0.60, 0.00, 1.00)
   colors[clr.TextSelectedBg] = ImVec4(0.25, 1.00, 0.00, 0.43)
   colors[clr.ModalWindowDarkening] = ImVec4(1.00, 0.98, 0.95, 0.73)
end
apply_custom_style()